// --------------------------------------------------
// CONSOLE FOR HATP (MODULE)
// --------------------------------------------------

#include <iostream>
#include <QApplication>
#include "MsgThread.hh"
#include "MainWindow.hh"

using namespace std;

int main(int argc, char *argv[]){

    QApplication app(argc, argv);
 
	if(argc < 3 || argc > 4) {
		cerr << "usage: HATPConsole MP_SERVER MP_PORT automatic_img_save(optional)" << endl;
		exit(1);
	}

	string MP_SERVER = argv[1];
	string MP_PORT	 = argv[2];
	bool automaticSave = false;
	if(argc == 4 && atoi(argv[3]) == 1) {
		automaticSave = true;
		cout << "[DEBUG]" << "launching HATPConsole with automatic images save option..."<<endl;
	}

	MsgThread *thread = new MsgThread();
	thread->startListening(MP_SERVER, MP_PORT);

	if(!thread->testConnection()) {
		cerr << "Unable to connect to MsgConnector Server... exited." << endl;
		exit(1);
	}


    MainWindow fenetre(thread);
    fenetre.setAutomaticImgSave(automaticSave);
	fenetre.setApplicationTitle("HATP Console (VIEWER)");

	fenetre.addSystemMessage("Waiting for connection...");
	fenetre.setStatusMessage("Waiting for connection...");


    fenetre.show();

	
	return app.exec();
}
